Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.scheduling.quartz
Class JobDetailFactoryBean

    java.lang.Object
      org.springframework.scheduling.quartz.JobDetailFactoryBean

All Implemented Interfaces:
  Aware, BeanNameAware, FactoryBean<org.quartz.JobDetail>, InitializingBean, ApplicationContextAware

    public class JobDetailFactoryBean

extends java.lang.Object
implements FactoryBean<org.quartz.JobDetail>, BeanNameAware, ApplicationContextAware, InitializingBean

A Spring `FactoryBean` for creating a Quartz `JobDetail` instance, supporting bean-style usage for JobDetail configuration.

`JobDetail(Impl)` itself is already a JavaBean but lacks sensible defaults. This class uses the Spring bean name as job name, and the Quartz default group ("DEFAULT") as job group if not specified.

NOTE: This FactoryBean works against both Quartz 1.x and Quartz 2.0/2.1, in contrast to the older `JobDetailBean` class.

Since:
  3.1
Author:
  Juergen Hoeller
See Also:
  `setName(java.lang.String)`, `setGroup(java.lang.String)`, `BeanNameAware`, `Scheduler.DEFAULT_GROUP`

Constructor Summary
`JobDetailFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
`org.quartz.JobDataMap` | `getJobDataMap()` Return the job's JobDataMap.
`org.quartz.JobDetail` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`java.lang.Class<?>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` | `setApplicationContext(ApplicationContext applicationContext)` Set the ApplicationContext that this object runs in.
`void` | `setApplicationContextJobDataKey(java.lang.String applicationContextJobDataKey)` Set the key of an ApplicationContext reference to expose in the JobDataMap, for example "applicationContext".
`void` | `setBeanName(java.lang.String beanName)` Set the name of the bean in the bean factory that created this bean.
`void` | `setDescription(java.lang.String description)` Set a textual description for this job.
`void` | `setDurability(boolean durability)` Specify the job's durability, i.e.
`void` | `setGroup(java.lang.String group)` Specify the job's group.
`void` | `setJobClass(java.lang.Class jobClass)` Specify the job's implementation class.
`void` | `setJobDataAsMap(java.util.Map<java.lang.String,?> jobDataAsMap)` Register objects in the JobDataMap via a given Map.
`void` | `setJobDataMap(org.quartz.JobDataMap jobDataMap)` Set the job's JobDataMap.
`void` | `setName(java.lang.String name)` Specify the job's name.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JobDetailFactoryBean

    public JobDetailFactoryBean()

Method Detail

### setName

    public void setName(java.lang.String name)

  Specify the job's name.

### setGroup

    public void setGroup(java.lang.String group)

  Specify the job's group.

### setJobClass

    public void setJobClass(java.lang.Class jobClass)

  Specify the job's implementation class.

### setJobDataMap

    public void setJobDataMap(org.quartz.JobDataMap jobDataMap)

  Set the job's JobDataMap.

  See Also:
    `setJobDataAsMap(java.util.Map)`

### getJobDataMap

    public org.quartz.JobDataMap getJobDataMap()

  Return the job's JobDataMap.

### setJobDataAsMap

    public void setJobDataAsMap(java.util.Map<java.lang.String,?> jobDataAsMap)

  Register objects in the JobDataMap via a given Map.

  These objects will be available to this Job only, in contrast to objects in the SchedulerContext.

  Note: When using persistent Jobs whose JobDetail will be kept in the database, do not put Spring-managed beans or an ApplicationContext reference into the JobDataMap but rather into the SchedulerContext.

  Parameters:
    `jobDataAsMap` - Map with String keys and any objects as values (for example Spring-managed beans)
  See Also:
    `SchedulerFactoryBean.setSchedulerContextAsMap(java.util.Map)`

### setDurability

    public void setDurability(boolean durability)

  Specify the job's durability, i.e. whether it should remain stored in the job store even if no triggers point to it anymore.

### setDescription

    public void setDescription(java.lang.String description)

  Set a textual description for this job.

### setBeanName

    public void setBeanName(java.lang.String beanName)

  Description copied from interface: `BeanNameAware`
  Set the name of the bean in the bean factory that created this bean.

  Invoked after population of normal bean properties but before an init callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

  Specified by:
    `setBeanName` in interface `BeanNameAware`
  Parameters:
    `beanName` - the name of the bean in the factory. Note that this name is the actual bean name used in the factory, which may differ from the originally specified name: in particular for inner bean names, the actual bean name might have been made unique through appending "#..." suffixes. Use the `BeanFactoryUtils.originalBeanName(String)` method to extract the original bean name (without suffix), if desired.

### setApplicationContext

    public void setApplicationContext(ApplicationContext applicationContext)

  Description copied from interface: `ApplicationContextAware`
  Set the ApplicationContext that this object runs in. Normally this call will be used to initialize the object.

  Invoked after population of normal bean properties but before an init callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method. Invoked after `ResourceLoaderAware.setResourceLoader(org.springframework.core.io.ResourceLoader)`, `ApplicationEventPublisherAware.setApplicationEventPublisher(org.springframework.context.ApplicationEventPublisher)` and `MessageSourceAware`, if applicable.

  Specified by:
    `setApplicationContext` in interface `ApplicationContextAware`
  Parameters:
    `applicationContext` - the ApplicationContext object to be used by this object
  See Also:
    `BeanInitializationException`

### setApplicationContextJobDataKey

    public void setApplicationContextJobDataKey(java.lang.String applicationContextJobDataKey)

  Set the key of an ApplicationContext reference to expose in the JobDataMap, for example "applicationContext". Default is none. Only applicable when running in a Spring ApplicationContext.

  In case of a QuartzJobBean, the reference will be applied to the Job instance as bean property. An "applicationContext" attribute will correspond to a "setApplicationContext" method in that scenario.

  Note that BeanFactory callback interfaces like ApplicationContextAware are not automatically applied to Quartz Job instances, because Quartz itself is responsible for the lifecycle of its Jobs.

  Note: When using persistent job stores where JobDetail contents will be kept in the database, do not put an ApplicationContext reference into the JobDataMap but rather into the SchedulerContext.

  See Also:
    `SchedulerFactoryBean.setApplicationContextSchedulerContextKey(java.lang.String)`, `ApplicationContext`

### afterPropertiesSet

    public void afterPropertiesSet()

  Description copied from interface: `InitializingBean`
  Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

  This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`

### getObject

    public org.quartz.JobDetail getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<org.quartz.JobDetail>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<?> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<org.quartz.JobDetail>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<org.quartz.JobDetail>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD